<?php

namespace app\Middleware;

use \Exception;
use \vendor\JWT\JWT;
use \vendor\Controller;
use \vendor\DB;
use \app\Controllers\Member as MemberController;

class AuthMiddleware
{
    public static function checkToken()
    {
        $headers = getallheaders();
        $jwt = $headers['Authorization'];
        $secret_key = "HELLO";
        try {
            $payload = JWT::decode($jwt, $secret_key, array('HS256'));
            $jwt = self::genToken($payload->data->id);
            $response['status'] = 200;
            $response['message'] = "Access granted";
            $response['token'] = $jwt;
        } catch (Exception $e) {
            $response['status'] = 403;
            $response['message'] = $e->getMessage();
        }
        return $response;
    }
    public static function doLogin()
    {
        $id = $_POST['Email'];
        $password = $_POST['password'];
        //查詢DB驗證帳密的正確性
        $status = count(DB::select("SELECT * FROM `Member` WHERE `Email`=? AND `Password`=?", array($id, $password))["result"]);

        $isgetRole = DB::select("SELECT * FROM `UserRole` WHERE `user_id`=?", array($id));
        // var_dump($status);
        if ($status == 1) {
            $response['status'] = 200;
            $response['message'] = "Access granted";
            $response['token'] = self::genToken($id);
        } else {
            $response['status'] = 403;
            $response['message'] = "Access denied";
        }
        return $response;
    }

    public static function getEmail()
    {
        $headers = getallheaders();
        $jwt = $headers['Authorization'];
        $secret_key = "HELLO";
        $payload = JWT::decode($jwt, $secret_key, array('HS256'));
        return $payload->data->id;
    }

    public static function getUser()
    {
        $id = self::getEmail();
        $sql = "SELECT * FROM `Member` WHERE `Email`=?";
        $arg = array($id);
        return DB::select($sql, $arg);
    }

    public static function checkPerms($action)
    {
        $id = self::getUser()["result"][0]["id"];
        $sql = "(SELECT role_id from user_role where user_id=?)
        INTERSECT
        (select role_action.role_id from action, role_action where action.name = ? and role_action.action_id=action.id)";
        $arg = array($id, $action);
        $result = DB::select($sql, $arg);
        if (count($result['result']) >= 1) {
            return true;
        } else {
            return false;
        }
    }

    private static function genToken($id)
    {
        $secret_key = "HELLO";
        $issuer_claim = "http://localhost";
        $audience_claim = "http://localhost";
        $issuedat_claim = time(); // issued at
        $expire_claim = $issuedat_claim + 6000;
        $payload = array(
            "iss" => $issuer_claim,
            "aud" => $audience_claim,
            "iat" => $issuedat_claim,
            "exp" => $expire_claim,
            "data" => array(
                "id" => $id,
            )
        );
        $jwt = JWT::encode($payload, $secret_key);
        return $jwt;
    }
}
